/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define INTERVAL   50    /* R}̃^C~O */
#define ARC        40    /* ~̃TCY */
#define LEFT        0    /* ̕ǂ x W */
#define RIGHT     400    /* E̕ǂ x W */
#define Yr         20    /* ԉ~ y W */
#define Yg         80    /* Ή~ y W */
#define Yb        140    /* ~ y W */
#define STEP        5    /* 1R}ňړ鋗 */
#define LtoR        0    /* ~̈ړ: E */
#define RtoL        1    /* ~̈ړ: E獶 */

#define BUFFER0     0    /* obt@0 */
#define BUFFER1     1    /* obt@1 */

static GC gc;
static XtIntervalId timeout_id;
static int position = LEFT;  /* ݂̉~ x W */
static int direction = LtoR;  /* LtoR: EɈړ, RtoL: Ɉړ */
static Dimension width, height;  /* `̈̃TCY */

static Colormap colormap;
static unsigned long planes[4], pixels[1];  /* v[ƃx[XsNZ */
/* (1) 4̐F̍\̂` */
static XColor yellow = {0, 65535, 65535,     0, DoRed | DoGreen | DoBlue, 0};
static XColor red    = {0, 65535,     0,     0, DoRed | DoGreen | DoBlue, 0};
static XColor green  = {0,     0, 65535,     0, DoRed | DoGreen | DoBlue, 0};
static XColor blue   = {0,     0,     0, 65535, DoRed | DoGreen | DoBlue, 0};
/* (2) J[}bv`p̔z: colors0 => BUFFER0, colors1 => BUFFER1 */
static XColor colors0[16], colors1[16];
static Boolean which = BUFFER0;  /* ŏɕ`̂̓obt@0 */

static void TimeoutCB();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, canvas;
    Arg al[20];
    int ac;
    int depth;
    int i;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Animation", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtManageChild(canvas);

    XtRealizeWidget(toplevel);

    /* h[GÃEBhẼTCY𒲂ׂ */
    XtVaGetValues(canvas, XmNwidth, &width,
                          XmNheight, &height, NULL);

    /* OtBbNEReLXg𐶐 */
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);

    /* (3) ftHg̃J[}bv𓾂 */
    colormap = DefaultColormapOfScreen(XtScreen(canvas));

    /* (4) _uobt@pɃJ[Zt */
    if (XAllocColorCells(XtDisplay(canvas), colormap,
                         False, planes, 4, pixels, 1) == 0) {
        fprintf(stderr, "Cannot allocate color cells.\n");
        exit(1);
    }

    /* (5) BUFFER0 p̐Fzp */
    /* (6) eF 4J[Zgp */
    for (i = 0; i < 16; i++) {
        if ((i / 4) == 0)  colors0[i] = yellow; /* colors0[]   0 -  3 */
        if ((i / 4) == 1)  colors0[i] = red;    /* colors0[]   4 -  7 */
        if ((i / 4) == 2)  colors0[i] = green;  /* colors0[]   8 - 11 */
        if ((i / 4) == 3)  colors0[i] = blue;   /* colors0[]  11 - 15 */
    }
    /* (7) planes[0]  planes[1] ŐFI */
    for (i = 0; i < 16; i++) {
        if ((i / 4) == 0)  colors0[i].pixel = pixels[0];
        if ((i / 4) == 1)  colors0[i].pixel = pixels[0]|planes[0];
        if ((i / 4) == 2)  colors0[i].pixel = pixels[0]|planes[1];
        if ((i / 4) == 3)  colors0[i].pixel = pixels[0]|planes[0]|planes[1];
    }
    /* (8) BUFFER1  planes[2]  planes[3] ̒lɈˑȂ */
    for (i = 0; i < 16; i++) {
        if ((i % 4) == 1)  colors0[i].pixel |= planes[2];
        if ((i % 4) == 2)  colors0[i].pixel |= planes[3];
        if ((i % 4) == 3)  colors0[i].pixel |= planes[2]|planes[3];
    }

    /* (9) BUFFER1 p̐Fzp */
    /* (10) eF 4J[Zgp */
    for (i = 0; i < 16; i++) {
        if ((i / 4) == 0)  colors1[i] = yellow; /* colors1[]   0 -  3 */
        if ((i / 4) == 1)  colors1[i] = red;    /* colors1[]   4 -  7 */
        if ((i / 4) == 2)  colors1[i] = green;  /* colors1[]   8 - 11 */
        if ((i / 4) == 3)  colors1[i] = blue;   /* colors1[]  11 - 15 */
    }
    /* (11) planes[2]  planes[3] ŐFI */
    for (i = 0; i < 16; i++) {
        if ((i / 4) == 0)  colors1[i].pixel = pixels[0];
        if ((i / 4) == 1)  colors1[i].pixel = pixels[0]|planes[2];
        if ((i / 4) == 2)  colors1[i].pixel = pixels[0]|planes[3];
        if ((i / 4) == 3)  colors1[i].pixel = pixels[0]|planes[2]|planes[3];
    }
    /* (12) BUFFER0  planes[0]  planes[1] ̒lɈˑȂ */
    for (i = 0; i < 16; i++) {
        if ((i % 4) == 1)  colors1[i].pixel |= planes[0];
        if ((i % 4) == 2)  colors1[i].pixel |= planes[1];
        if ((i % 4) == 3)  colors1[i].pixel |= planes[0]|planes[1];
    }

    /* ŏɕ`̂ BUFFER0 Ȃ̂ŁC\ BUFFER1 ̐F\ɂĂ */
    XStoreColors(XtDisplay(canvas), colormap, colors1, 16);

    /* wiF yellow (x[XsNZl pixels[0]) ɐݒ */
    XtVaSetValues(canvas, XmNbackground, pixels[0], NULL);

    /* ^CAEgER[obNo^ */
    timeout_id = XtAppAddTimeOut(app_context, INTERVAL, TimeoutCB, canvas);

    XtAppMainLoop(app_context);
}

static void TimeoutCB(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget w = (Widget)client_data;

    /* (13) v[}XNZbg */
    if (which == BUFFER0)
        XSetPlaneMask(XtDisplay(w), gc, planes[0] | planes[1]);
    else
        XSetPlaneMask(XtDisplay(w), gc, planes[2] | planes[3]);

    /* (14) obt@NA */
    XSetForeground(XtDisplay(w), gc, 0);
    XFillRectangle(XtDisplay(w), XtWindow(w), gc, 0, 0, width, height);

    /* (15) ̉~̈ʒu߂ */
    if (direction == LtoR) {             /* ܂ōEɓĂ */
        position += STEP;                /* ̈ʒuɐi߂ */
        if (position > (RIGHT - ARC)) {  /* ǂɓ甽] */
            position = (RIGHT - ARC) - (position - (RIGHT - ARC));
            direction = RtoL;
        }
    }
    else { /* direction == RtoL */  /* ܂ŉE獶ɓĂ */
        position -= STEP;           /* ̈ʒuɐi߂ */
        if (position < LEFT) {      /* ǂɓ甽] */
            position = LEFT - (position - LEFT);
            direction = LtoR;
        }
    }

    /* (16) e~̐FZbgāC̈ʒuɉ~` */
    XSetForeground(XtDisplay(w), gc, planes[0]|planes[2]);
    XFillArc(XtDisplay(w), XtWindow(w), gc, position, Yr, ARC,ARC, 0*64,360*64);
    XSetForeground(XtDisplay(w), gc, planes[1]|planes[3]);
    XFillArc(XtDisplay(w), XtWindow(w), gc, position, Yg, ARC,ARC, 0*64,360*64);
    XSetForeground(XtDisplay(w), gc, planes[0]|planes[1]|planes[2]|planes[3]);
    XFillArc(XtDisplay(w), XtWindow(w), gc, position, Yb, ARC,ARC, 0*64,360*64);

    /* (17) J[}bv̐FύX (Oʃobt@Ɣwʃobt@ւ) */
    if (which == BUFFER0) {
        XStoreColors(XtDisplay(w), colormap, colors0, 16);
        which = BUFFER1;
    }
    else {
        XStoreColors(XtDisplay(w), colormap, colors1, 16);
        which = BUFFER0;
    }

    /* Ăу^CAEgER[obNĂяo悤ɂ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(w),
                                 INTERVAL, TimeoutCB, w);
}
