/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void CopyCB();
static void PasteCB();
static Widget box, figure, title;
static Pixmap pixmap;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Clip2type", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* (1) Gƃx͂ޔ */
    ac = 0;
    box = XmCreateRowColumn(panel, "box", al, ac);
    XtManageChild(box);
    /* G */
    ac = 0;
    figure = XmCreateLabel(box, "figure", al, ac);
    XtManageChild(figure);
    /* x */
    ac = 0;
    title = XmCreateLabel(box, "title", al, ac);
    XtManageChild(title);

    /* (2) [Rs[] --> Nbv{[hɃf[^Rs[ */
    ac = 0;
    copy = XmCreatePushButton(panel, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, NULL);
    XtManageChild(copy);

    /* (3) [y[Xg] --> Nbv{[hf[^o */
    ac = 0;
    paste = XmCreatePushButton(panel, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);
    XtManageChild(paste);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* (4) [Rs[] {^̃R[obN */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmString label;
    long item_id;
    static int private_id = 0;
    long data_id;
    XmString string;
    char *text;

    /* (5) figure G (sbNX}bv) o */
    XtVaGetValues(figure, XmNlabelPixmap, &pixmap, NULL);

    /* (6) title 烉xo */
    XtVaGetValues(title, XmNlabelString, &string, NULL);
    XmStringGetLtoR(string, XmFONTLIST_DEFAULT_TAG, &text);
    XmStringFree(string);

    /* sbNX}bvx̏񂪎ȂƃG[ */
    if (pixmap == XmUNSPECIFIED_PIXMAP || text == NULL) {
        XBell(XtDisplay(w), 0);
        return;
    }

    /* KȖOŃRpEhEXgOĂ */
    label = XmStringCreateLocalized("_my_data");

    /* (7) Nbv{[hւ̃Rs[Jn */
    if (XmClipboardStartCopy(XtDisplay(box), XtWindow(box), label,
                             XtLastTimestampProcessed(XtDisplay(box)),
                             NULL, NULL, &item_id) != ClipboardSuccess) {
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        XtFree(text);
        return;
    }
    /* (8) Nbv{[hɃsbNX}bv ID Rs[ */
    if (XmClipboardCopy(XtDisplay(box), XtWindow(box), item_id,
                        "PIXMAP", &pixmap, sizeof(pixmap), private_id,
                        &data_id) != ClipboardSuccess) {
        XmClipboardCancelCopy(XtDisplay(text), XtWindow(text), item_id);
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        XtFree(text);
        return;
    }
    /* (9) Nbv{[hɃ^Cg̕Rs[ */
    if (XmClipboardCopy(XtDisplay(box), XtWindow(box), item_id,
                        "STRING", text, strlen(text), private_id,
                        &data_id) != ClipboardSuccess) {
        XmClipboardCancelCopy(XtDisplay(text), XtWindow(text), item_id);
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        XtFree(text);
        return;
    }
    /* (10) Nbv{[hւ̃Rs[I (ۂɃf[^]) */
    if (XmClipboardEndCopy(XtDisplay(box), XtWindow(box), item_id)
                                                         != ClipboardSuccess) {
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        XtFree(text);
        return;
    }
    private_id++;
    XmStringFree(label);
    XtFree(text);
}

/* (11) [y[Xg] {^̃R[obN */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    char buff[BUFSIZ];
    unsigned long num_bytes;
    long private_id;
    XmString string;

    /* (12) f[^̎oJn */
    if (XmClipboardStartRetrieve(XtDisplay(box), XtWindow(box),
              XtLastTimestampProcessed(XtDisplay(box))) != ClipboardSuccess) {
        XBell(XtDisplay(w), 0);
        return;
    }

    /* (13) Nbv{[hsbNX}bv ID o */
    if (XmClipboardRetrieve(XtDisplay(box), XtWindow(box),
                         "PIXMAP", &pixmap, sizeof(pixmap), &num_bytes,
                         &private_id) != ClipboardSuccess || num_bytes == 0) {
        XBell(XtDisplay(w), 0);
        return;
    }
    /* (14) osbNX}bv figure ɕ\ */
    XtVaSetValues(figure, XmNlabelPixmap, pixmap, NULL);

    /* (15) Nbv{[h^Cg̕o */
    if (XmClipboardRetrieve(XtDisplay(box), XtWindow(box),
                         "STRING", buff, sizeof(buff), &num_bytes,
                         &private_id) != ClipboardSuccess || num_bytes == 0) {
        XBell(XtDisplay(w), 0);
        return;
    }
    buff[num_bytes] = '\0';  /* Ō NULL t */

    /* (16)o title ɕ\ */
    string = XmStringCreateLocalized(buff);
    XtVaSetValues(title, XmNlabelString, string, NULL);
    XmStringFree(string);

    /* (17)f[^̎oI */
    XmClipboardEndRetrieve(XtDisplay(box), XtWindow(box));
}
