/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void OpenCB();
static void CopyCB();
static void PasteCB();
static Boolean ConvertIncProc();
static void LoseIncProc();
static void DoneIncProc();
static void CancelProc();
static void GetValueProc();

#define MAX_LEN 1024
static Widget text;
static char *string;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, field, label, fname, open, control, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Selectincr", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* (1) t@C͂ăI[v̈ */
    ac = 0;
    field = XmCreateRowColumn(panel, "field", al, ac);
    XtManageChild(field);
    /* "t@C: */
    ac = 0;
    label = XmCreateLabel(field, "label", al, ac);
    XtManageChild(label);
    /* ͗̈ */
    ac = 0;
    fname = XmCreateTextField(field, "fname", al, ac);
    XtManageChild(fname);
    /* [I[v] */
    ac = 0;
    open = XmCreatePushButton(field, "open", al, ac);
    XtAddCallback(open, XmNactivateCallback, OpenCB, fname);
    XtManageChild(open);

    /* (2) t@C̓e\̈ */
    ac = 0;
    text = XmCreateScrolledText(panel, "text", al, ac);
    XtManageChild(text);

    /* (3) ̈ */
    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);
    /* [Rs[] {^ --> L: ZNVL */
    ac = 0;
    copy = XmCreatePushButton(control, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, NULL);
    XtManageChild(copy);
    /* [y[Xg] {^ --> v: ZNVEf[^v */
    ac = 0;
    paste = XmCreatePushButton(control, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);
    XtManageChild(paste);

    XtVaSetValues(XtParent(text), XmNtopWidget, field,
                                  XmNbottomWidget, control, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* (4) [I[v] {^̃R[obN */
static void OpenCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget textf = (Widget)client_data;
    char *filename;
    FILE *fp;
    char buff[BUFSIZ];

    /* (5) ͂ꂽt@Co */
    XtVaGetValues(textf, XmNvalue, &filename, NULL);

    /* (6) t@C̓eeLXgɕ\ */
    if ((fp = fopen(filename, "r")) != NULL) {  /* t@CI[v */
        XmTextSetString(text, "");  /* eLXg̓e */
        while (fgets(buff, BUFSIZ, fp) != NULL)
            XmTextInsert(text, XmTextGetLastPosition(text), buff); /* ǉ */
        fclose(fp);
    }

    XtFree(filename);
}

/* (7) L: [Rs[] {^̃R[obN */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    /* (8) ZNVL (R[obNo^) */
    if (XtOwnSelectionIncremental(text, XA_PRIMARY,
                   XtLastTimestampProcessed(XtDisplay(text)),
                   ConvertIncProc, LoseIncProc, DoneIncProc, CancelProc, NULL))
        /* (9) LłCeLXg\Ēm点 */
        XmTextSetHighlight(text, 0, XmTextGetLastPosition(text),
                           XmHIGHLIGHT_SELECTED);
}

/* L: ZNV̏LƂɌĂяo */
static void LoseIncProc(w, selection, client_data)
    Widget w;
    Atom *selection;
    XtPointer client_data;
{
    /* (10) ZNV̏L҂łȂȂC\ */
    if (*selection == XA_PRIMARY)
        XmTextSetHighlight(w, 0, XmTextGetLastPosition(w), XmHIGHLIGHT_NORMAL);
}

/* (11) v: [y[Xg] {^̃R[obN */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    /* (12) ZNṼf[^v (f[^̓R[obNŎ󂯎) */
    XtGetSelectionValueIncremental(text, XA_PRIMARY, XA_STRING, GetValueProc,
                              NULL, XtLastTimestampProcessed(XtDisplay(text)));
}

/* (13) L: ZNṼf[^vꂽƂɌĂяo */
static Boolean ConvertIncProc(w, selection, target,
                              type_ret, val_ret, len_ret, format_ret,
                              max_len, client_data, request_id)
    Widget w;
    Atom *selection;
    Atom *target;
    Atom *type_ret;
    XtPointer *val_ret;
    unsigned long *len_ret;
    int *format_ret;
    unsigned long *max_len;
    XtPointer client_data;
    XtRequestId *request_id;
{
    static char *p;
    static Boolean start = True;
    static XtRequestId id;
    unsigned long size;

    if (*selection != XA_PRIMARY || *target != XA_STRING)
        return False;  /* vꂽZNVƃ^CvႤ */

    /* (14) CN^]Jn */
    if (start) {
        p = string = XmTextGetString(w);  /* eLXg̓eo */
        id = *request_id;  /* v ID oĂ */
        start = False;
    }

    /* (15) CN^]́Cʂ̗v󂯕tȂ */
    if (id != *request_id)
        return False;

    /* (16) ̓]f[^Ԃ */
    size = strlen(p);  /* c̃TCY */
    if (size > MAX_LEN) size = MAX_LEN;    /* 1̓]TCY𐧌 */
    if (size > *max_len) size = *max_len;  /* ]TCYlȓ */
    *val_ret = p;           /* ]f[^̐擪|C^ */
    *len_ret = size;        /* ]TCY (size = 0 Ɠ]I) */
    *type_ret = XA_STRING;  /* ̗͉p̃eLXĝ݈ */
    *format_ret = 8;        /* ̃tH[}bg 8 */

    if (size == 0)  /* (17) c̃f[^Ȃ (]) */
        start = True;
    else
        p += size;  /* (18) ɓ]f[^̈ʒu܂Ői߂Ă */

    return True;   /* ]f[^̏ɐƂ} */
}

/* (19) v: ZNṼf[^󂯎ƂɌĂяo */
static void GetValueProc(w, client_data, selection, type, val, len, format)
    Widget w;
    XtPointer client_data;
    Atom *selection;
    Atom *type;
    XtPointer val;
    unsigned long *len;
    int *format;
{
    static Boolean start = True;

    if (*selection != XA_PRIMARY || *type != XA_STRING || val == NULL) {
        XBell(XtDisplay(w), 0);  /* xŎs̍} */
        return;
    }

    /* (20) CN^]̊ */
    if (*len == 0) {
        start = True;
        return;
    }

    /* (21) ŏɃeLXg̓eNA */
    if (start) {
        XmTextSetString(w, "");
        start = False;
    }

    /* (22) 󂯎f[^eLXgEEBWFbgɒǉ */
    XmTextInsert(text, XmTextGetLastPosition(text), (char *)val);
    XtFree((char *)val);
}

/* (23) L: v҂f[^󂯎ŌĂяo */
static void DoneIncProc(w, selection, target, request_id, client_data)
    Widget w;
    Atom *selection;
    Atom *target;
    XtRequestId *request_id;
    XtPointer client_data;
{
    /* (24) ]p̃f[^ */
    XtFree(string);
}

/* (25) L: f[^]~ꂽƂɌĂяo */
static void CancelProc(w, selection, target, request_id, client_data)
    Widget w;
    Atom *selection;
    Atom *target;
    XtRequestId *request_id;
    XtPointer client_data;
{
    /* (26) ]p̃f[^ */
    XtFree(string);
}
